import { Http } from '@angular/http';
import { Component, NgModule, ViewChild } from '@angular/core';
import { HomeService } from './home.service';
import { IHome } from './home';
@Component({
    selector: 'my-app',
    template: `<h1 id='mainheader'>My IgniteUI Angular2 App</h1>
    <h2>igGrid</h2>
<button type="button" id="btnSave" class="btn btn-success no-print" data-toggle="tooltip" data-placement="top" title="Save" (click)="saveGrid()">Save</button>
<ig-grid [(options)]="gridOptions" [(widgetId)]='id' [(dataSource)]="gridHome"></ig-grid>
    <div id='customValidator'></div>
    <ig-validator [options]='validatorOpts'  widgetId='customValidator'></ig-validator>
    <script id="dialogtemp" type="text/html">
    <div>
    <table style="width: 100%;">
        <tr>
            <td style="width: 30%;">
                <strong>User Id</strong>
            </td>
            <td style="width: 70%;">
                <input data-editor-for-userId="true" />
            </td>
        </tr>
        <tr>
            <td style="width: 30%;">
                <strong>ID</strong>
            </td>
            <td style="width: 70%;">
                <input data-editor-for-id="true" />
            </td>
        </tr>
        <tr>
            <td style="width: 30%;">
                <strong>Title</strong>
            </td>
            <td style="width: 70%;">
                <input data-editor-for-title="true" />
            </td>
        </tr>
        <tr>
            <td style="width: 30%;">
                <strong>Body</strong>
            </td>
            <td style="width: 70%;">
                <input data-editor-for-body="true" />
            </td>
        </tr>
    </table>
</div>
</script>
    `,
    providers: [HomeService]
})
export class AppComponent {
    private gridOptions: IgGrid;
    private id: string;
    private errorMessage: string;
    private gridHome: IHome[] = [];
    private users: any[] = [];
    private validatorOpts: any;
    private validationRes: boolean  = true;

    ngOnInit(): void {

        this._homeService.getHome()
            .subscribe(data => {
                this.gridHome = data;

            },
            error => this.errorMessage = <any>error);


        this._homeService.getUsers()
            .subscribe(data => {
                this.users = data;

            },
            error => this.errorMessage = <any>error);



    }

  constructor(private _homeService: HomeService) {
        var me = this;

        this.validatorOpts ={
            fields:[],
             custom: {
                 onblur: true,
                 method: function (value, fieldOps) {
                     $("#TestTypeGrid_updating_dialog_container_footer_buttonok").igButton("option", "disabled", !me.validationRes);
                      return me.validationRes;
                 },
                errorMessage: "user doesn't exist"
           }
        };

        //this.data = this.ErrorTypes;
        this.id = 'TestTypeGrid';
        this.gridOptions = {

            //autoCommit: true,
            dataSource: this.gridHome,
            width: "100%",
            height: "710px",
            autoGenerateColumns: false,
           
            rendered: (e, ui) => {
                //ui.owner.dataSource.settings.restSettings.contentType = undefined;
                //$.ajaxSetup({
                //    url: "",
                //    xhrFields: {
                //        withCredentials: true
                //    }
                //})
            },
            columns: [
                { key: "userId", headerText: "userId", width: "20%", dataType: "number" },
                { key: "id", headerText: "id", width: "20%", dataType: "number" },
                { key: "title", headerText: "title", width: "20%", dataType: "string" },
                { key: "body", headerText: "body", width: "60%", dataType: "string" },
            ],  
            primaryKey: "id",
            features: [
                {
                    name: "Updating",
                    editMode: "dialog",
                    rowEditDialogOptions: {
                        showEditorsForHiddenColumns: true,
                        showReadonlyEditors: false,
                        dialogTemplate: $("#dialogtemp").html()
                        },
                    rowEditDialogAfterOpen: function (e, ui) {
                        var validator = $("#customValidator").data("igValidator");
                        if( validator["options"].fields.length === 0 ){
                            $("#customValidator").igValidator("addField", { selector: $("input[data-editor-for-userId]") });
                        }
                    },
                    editRowStarted: function (evt, ui) {
                        //var editor = $("#TestTypeGrid").igGridUpdating("editorForKey", "userId");
                            //if (editor) {
                            //    editor.igCombo("option", "dataSource", me.users);
                            //    editor.igCombo("dataBind");
                            //}
                    },
                    columnSettings: [
                        { columnKey: "id", readOnly: true, editorType: 'text' },
                        {
                            columnKey: "userId",
                            editorType: 'text',
                           // required: true,
                            editorOptions: {
                                valueChanged: function(e, ui){
                                       me._homeService.validateUser(ui.newValue)
                                                .subscribe(data => {
                                                     if (data) {
                                                       me.validationRes = true;
                                                    } else {
                                                         me.validationRes = false;
                                                    }
                                                    jQuery("#customValidator").igValidator("validate");
                                    },  error => { 
                                        me.validationRes = false;
                                        jQuery("#customValidator").igValidator("validate");
                                    });
                                }
                            }
                            //editorOptions: {
                            //    mode: "dropdown",
                            //    dataSource: this.users,
                            //    textKey: "name",
                            //    valueKey: "id",
                               
                            //}
                        }
                    ]
                },
                {
                    name: "Paging"
                },
                {
                    name: "Filtering"
                },
                {
                    name: "Sorting"
                }
            ]
        }
    }
  clicked(){
      //trigger your remote call and in the result callback force validation by calling the validate method.
    this.validationRes = false;
    jQuery("#customValidator").igValidator("validate");
  }
    
 }

