"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var Rx_1 = require("rxjs/Rx");
var HomeService = (function () {
    function HomeService(_http) {
        this._http = _http;
        this._testUrl = 'https://jsonplaceholder.typicode.com/posts';
        this._userUrl = 'https://jsonplaceholder.typicode.com/users';
    }
    HomeService.prototype.getHome = function () {
        return this._http.get(this._testUrl, { withCredentials: true })
            .map(function (response) { return response.json(); })
            .do(function (data) { return console.log('All: ' + JSON.stringify(data)); })
            .catch(this.handleError);
    };
    HomeService.prototype.getUsers = function () {
        return this._http.get(this._userUrl, { withCredentials: true })
            .map(function (response) { return response.json(); })
            .do(function (data) { return console.log('Users: ' + JSON.stringify(data)); })
            .catch(this.handleError);
    };
    HomeService.prototype.validateUser = function (user) {
        return this._http.get(this._userUrl + "/" + user, { withCredentials: true })
            .map(function (response) { if (response) {
            return true;
        }
        else {
            return false;
        } })
            .do(function (data) { return console.log('users: ' + JSON.stringify(data)); });
    };
    HomeService.prototype.handleError = function (error) {
        console.error(error);
        return Rx_1.Observable.throw(error.json().error || 'Server error');
    };
    return HomeService;
}());
HomeService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], HomeService);
exports.HomeService = HomeService;
//# sourceMappingURL=home.service.js.map